<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/convert_access_class_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv2_p0 { color: #e0ffff; }
.textRainbow_lv1_o0 { color: #ffffe0; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/27/85  convert_access_class_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The convert_access_class_ subroutine is provided to convert an access
<span id="L5" class="LineNr">  5 </span>attribute in the Multics access isolation mechanism <span class="textRainbow_lv0_p0">(</span>AIM<span class="textRainbow_lv0_p0">)</span> back and
<span id="L6" class="LineNr">  6 </span>forth between its binary and character-string representations.
<span id="L7" class="LineNr">  7 </span>Additional entries provide the ability to encode an access attribute as
<span id="L8" class="LineNr">  8 </span>a short character string for use in entrynames.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>Entry points in convert_access_class_:
<span id="L12" class="LineNr"> 12 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>:Entry:  decode:  02/27/85 convert_access_class_$decode
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>Function:  This entry point takes the character string produced by the
<span id="L19" class="LineNr"> 19 </span>convert_access_class_$encode entry point and returns the original
<span id="L20" class="LineNr"> 20 </span>access attribute.  The null string and the string &quot;system_low&quot; are both
<span id="L21" class="LineNr"> 21 </span>converted to return the system_low access attribute.
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>Syntax:
<span id="L25" class="LineNr"> 25 </span>declare convert_access_class_$decode entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>call convert_access_class_$decode <span class="textRainbow_lv0_p0">(</span>acc_att<span class="textRainbow_lv0_o0">,</span> decoded_string<span class="textRainbow_lv0_p0">)</span>;
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>
<span id="L29" class="LineNr"> 29 </span>Arguments:
<span id="L30" class="LineNr"> 30 </span>acc_att
<span id="L31" class="LineNr"> 31 </span>   is the the decoded authorization.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L32" class="LineNr"> 32 </span>decoded_string
<span id="L33" class="LineNr"> 33 </span>   is a short string <span class="textRainbow_lv0_p0">(</span>maximum of 15 characters<span class="textRainbow_lv0_p0">)</span> that uniquely
<span id="L34" class="LineNr"> 34 </span>   represents the input access attribute.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>:Entry:  encode:  02/27/85 convert_access_class_$encode
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>Function:  This entry point encodes an access attribute into a short
<span id="L41" class="LineNr"> 41 </span>character string, suitable for inclusion in entrynames.  If the input
<span id="L42" class="LineNr"> 42 </span>access attribute represents system_low, the returned string is
<span id="L43" class="LineNr"> 43 </span>&quot;system_low&quot;.
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>Syntax:
<span id="L47" class="LineNr"> 47 </span>declare convert_access_class_$encode entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L48" class="LineNr"> 48 </span>call convert_access_class $encode <span class="textRainbow_lv0_p0">(</span>acc_att<span class="textRainbow_lv0_o0">,</span> encoded_string<span class="textRainbow_lv0_p0">)</span>;
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>Arguments:
<span id="L52" class="LineNr"> 52 </span>acc_att
<span id="L53" class="LineNr"> 53 </span>   is the input access attribute <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L54" class="LineNr"> 54 </span>encoded_string
<span id="L55" class="LineNr"> 55 </span>   is a short string <span class="textRainbow_lv0_p0">(</span>maximum of 15 characters<span class="textRainbow_lv0_p0">)</span> that uniquely
<span id="L56" class="LineNr"> 56 </span>   represents the input access attribute.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>:Entry:  from_string:  02/27/85 convert_access_class_$from_string
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>Function:  This entry point converts the character string
<span id="L63" class="LineNr"> 63 </span>representation of an access attribute to an encoded binary form
<span id="L64" class="LineNr"> 64 </span>suitable for storage in system tables and as input to the various
<span id="L65" class="LineNr"> 65 </span>modules that accept the binary form.
<span id="L66" class="LineNr"> 66 </span>
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>Syntax:
<span id="L69" class="LineNr"> 69 </span>declare convert_access_class_$from_string entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L70" class="LineNr"> 70 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L71" class="LineNr"> 71 </span>call convert_access_class_$from_string <span class="textRainbow_lv0_p0">(</span>acc_att<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>Arguments:
<span id="L75" class="LineNr"> 75 </span>acc_att
<span id="L76" class="LineNr"> 76 </span>   is the binary representation of string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L77" class="LineNr"> 77 </span>string
<span id="L78" class="LineNr"> 78 </span>   is the character string to be converted <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L79" class="LineNr"> 79 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L80" class="LineNr"> 80 </span>code
<span id="L81" class="LineNr"> 81 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be one of the following:
<span id="L82" class="LineNr"> 82 </span>   error_table_$ai_invalid_string
<span id="L83" class="LineNr"> 83 </span>      one or more namei is misspelled <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L84" class="LineNr"> 84 </span>   error_table_$ai_above_allowed_max
<span id="L85" class="LineNr"> 85 </span>      no error in conversion; but the resulting access attribute is
<span id="L86" class="LineNr"> 86 </span>      greater than the system_high access attribute.
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>Notes:  The string argument must be of the form:
<span id="L90" class="LineNr"> 90 </span>        name1,name2,...,nameN
<span id="L91" class="LineNr"> 91 </span>where namei represents the mnemonic for a sensitivity level or access
<span id="L92" class="LineNr"> 92 </span>category.  The print_auth_names command can be used to obtain a list of
<span id="L93" class="LineNr"> 93 </span>acceptable mnenomics.  If the string argument is null or system_low,
<span id="L94" class="LineNr"> 94 </span>the resulting authorization is level 0 and no categories.  If the
<span id="L95" class="LineNr"> 95 </span>string is system_high, the system access_ceiling is returned <span class="textRainbow_lv0_p0">(</span>the
<span id="L96" class="LineNr"> 96 </span>maximum access attribute allowed<span class="textRainbow_lv0_p0">)</span>.
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>:Entry:  from_string_range: 02/27/85 convert_access_class_$from_string_range
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>Function:  This entry point converts a character string to the form of
<span id="L103" class="LineNr">103 </span>a binary access attribute range.
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>Syntax:
<span id="L107" class="LineNr">107 </span>declare convert_access_class_$from_string_range entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned
<span id="L108" class="LineNr">108 </span>     dimension<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L109" class="LineNr">109 </span>call convert_access_class_$from_string_range <span class="textRainbow_lv0_p0">(</span>acc_att_range<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span>
<span id="L110" class="LineNr">110 </span>     code<span class="textRainbow_lv0_p0">)</span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>
<span id="L113" class="LineNr">113 </span>Arguments:
<span id="L114" class="LineNr">114 </span>acc_att_range
<span id="L115" class="LineNr">115 </span>   is the binary representation of string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L116" class="LineNr">116 </span>string
<span id="L117" class="LineNr">117 </span>   is the character string to be converted <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L118" class="LineNr">118 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L119" class="LineNr">119 </span>code
<span id="L120" class="LineNr">120 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be one of the following:
<span id="L121" class="LineNr">121 </span>   error_table_$ai_invalid_string
<span id="L122" class="LineNr">122 </span>      one or more namei are misspelled <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L123" class="LineNr">123 </span>   error_table_$ai_above_allowed_max
<span id="L124" class="LineNr">124 </span>      no error in conversion; but the resulting access attribute is
<span id="L125" class="LineNr">125 </span>      greater than the system_high access attribute.
<span id="L126" class="LineNr">126 </span>   error_table_$ai_invalid_range
<span id="L127" class="LineNr">127 </span>      no error in conversion; but acc_att_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> does not represent
<span id="L128" class="LineNr">128 </span>      an access attribute greater than or equal to acc_att_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>.
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>Notes:  The string must be one of the two forms:
<span id="L132" class="LineNr">132 </span>        name1,name2,...,nameN
<span id="L133" class="LineNr">133 </span>        name1a,name2a,...,nameNa:name1b,name2b,...nameNb
<span id="L134" class="LineNr">134 </span>where namei represents the mnemonic for a sensitivity level or access
<span id="L135" class="LineNr">135 </span>category.  If the string is in the first form, both elements of
<span id="L136" class="LineNr">136 </span>acc_att_range will be set to equal values <span class="textRainbow_lv0_p0">(</span>similar to the operation of
<span id="L137" class="LineNr">137 </span>convert_access_class_$from_string<span class="textRainbow_lv0_p0">)</span>.  If string is in the second form,
<span id="L138" class="LineNr">138 </span>acc_att_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> will be returned as the binary representation of the
<span id="L139" class="LineNr">139 </span>part of string left of the colon, and acc_att_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> will be
<span id="L140" class="LineNr">140 </span>returned as the binary representation of the part of the string right
<span id="L141" class="LineNr">141 </span>of the colon.
<span id="L142" class="LineNr">142 </span>
<span id="L143" class="LineNr">143 </span>
<span id="L144" class="LineNr">144 </span>:Entry:  minimum:  02/27/85 convert_access_class_$minimum
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Function:  This entry point accepts an array of access attributes and a
<span id="L148" class="LineNr">148 </span>binary number indicating how many elements to process from the array.
<span id="L149" class="LineNr">149 </span>It returns an access attribute class whose category set is the
<span id="L150" class="LineNr">150 </span>intersection of all input category sets and whose sensitivity level is
<span id="L151" class="LineNr">151 </span>the minimum of all input sensitivity levels.  The returned value need
<span id="L152" class="LineNr">152 </span>not equal any of the input values.
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>Syntax:
<span id="L156" class="LineNr">156 </span>declare convert_access_class_$minimum entry <span class="textRainbow_lv0_p0">(</span>dim<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L157" class="LineNr">157 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_p0">)</span>;
<span id="L158" class="LineNr">158 </span>call convert_access_class_$minimum <span class="textRainbow_lv0_p0">(</span>acc_att_array<span class="textRainbow_lv0_o0">,</span> n_elements<span class="textRainbow_lv0_o0">,</span>
<span id="L159" class="LineNr">159 </span>     minimum_acc_att<span class="textRainbow_lv0_p0">)</span>
<span id="L160" class="LineNr">160 </span>
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>Arguments:
<span id="L163" class="LineNr">163 </span>acc_att_array
<span id="L164" class="LineNr">164 </span>   are the input access attributes<span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L165" class="LineNr">165 </span>n_elements
<span id="L166" class="LineNr">166 </span>   is the number of elements to be processed in the acc_att_array
<span id="L167" class="LineNr">167 </span>   argument.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L168" class="LineNr">168 </span>minimum_acc_att
<span id="L169" class="LineNr">169 </span>   is the result.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>:Entry:  to_string:  02/27/85 convert_access_class_$to_string
<span id="L173" class="LineNr">173 </span>
<span id="L174" class="LineNr">174 </span>
<span id="L175" class="LineNr">175 </span>Function:  This entry point accepts a binary form of an access
<span id="L176" class="LineNr">176 </span>attribute and returns it as a printable string.  This output string is
<span id="L177" class="LineNr">177 </span>suitable for input to the convert_access_class_$from_string entry
<span id="L178" class="LineNr">178 </span>point.  Each level/category name has a maximum length of 32 characters.
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>
<span id="L181" class="LineNr">181 </span>Syntax:
<span id="L182" class="LineNr">182 </span>declare convert_access_class_$to_string entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L183" class="LineNr">183 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L184" class="LineNr">184 </span>call convert_access_class_$to_string <span class="textRainbow_lv0_p0">(</span>acc_att<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L185" class="LineNr">185 </span>
<span id="L186" class="LineNr">186 </span>
<span id="L187" class="LineNr">187 </span>Arguments:
<span id="L188" class="LineNr">188 </span>acc_att
<span id="L189" class="LineNr">189 </span>   is the access attribute to be converted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L190" class="LineNr">190 </span>string
<span id="L191" class="LineNr">191 </span>   is the resultant character string <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L192" class="LineNr">192 </span>code
<span id="L193" class="LineNr">193 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be one of the following:
<span id="L194" class="LineNr">194 </span>   error_table_$smallarg
<span id="L195" class="LineNr">195 </span>      string is too short to hold the converted result <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot;
<span id="L196" class="LineNr">196 </span>      below<span class="textRainbow_lv0_p0">)</span>.
<span id="L197" class="LineNr">197 </span>   error table_$ai_invalid binary
<span id="L198" class="LineNr">198 </span>      either the level number or category set is invalid; the resulting
<span id="L199" class="LineNr">199 </span>      output is also invalid.
<span id="L200" class="LineNr">200 </span>
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>Notes:  When the error_table_$smallarg code is returned, as much of the
<span id="L203" class="LineNr">203 </span>resulting conversion as fits in the output string is returned.
<span id="L204" class="LineNr">204 </span>However, since the results are not complete, they should not be used as
<span id="L205" class="LineNr">205 </span>input to the convert_access_class_$from_string entry point.
<span id="L206" class="LineNr">206 </span>
<span id="L207" class="LineNr">207 </span>If the access attribute is equal to the site access ceiling as defined
<span id="L208" class="LineNr">208 </span>by the installation_parms and returned by system_info_$access_ceiling,
<span id="L209" class="LineNr">209 </span>then &quot;system_high&quot; is returned in the string.
<span id="L210" class="LineNr">210 </span>
<span id="L211" class="LineNr">211 </span>
<span id="L212" class="LineNr">212 </span>:Entry:  to_string_range: 02/27/85 convert_access_class_$to_string_range
<span id="L213" class="LineNr">213 </span>
<span id="L214" class="LineNr">214 </span>
<span id="L215" class="LineNr">215 </span>Function:  This entry point accepts a binary access attribute range
<span id="L216" class="LineNr">216 </span>pair and returns it as a printable string.  This output string is
<span id="L217" class="LineNr">217 </span>suitable for input to the convert_access_class_$from_string_range entry
<span id="L218" class="LineNr">218 </span>point.  Each level/category name has a maximum length of 32 characters.
<span id="L219" class="LineNr">219 </span>
<span id="L220" class="LineNr">220 </span>
<span id="L221" class="LineNr">221 </span>Syntax:
<span id="L222" class="LineNr">222 </span>declare convert_access_class_$to_string_range entry <span class="textRainbow_lv0_p0">(</span>bit <span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned
<span id="L223" class="LineNr">223 </span>     dimension <span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L224" class="LineNr">224 </span>call convert_access_class_$to_string_range <span class="textRainbow_lv0_p0">(</span>acc_att_range<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span>
<span id="L225" class="LineNr">225 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>
<span id="L228" class="LineNr">228 </span>Arguments:
<span id="L229" class="LineNr">229 </span>acc_att_range
<span id="L230" class="LineNr">230 </span>   is the binary representation of an access attribute range to be
<span id="L231" class="LineNr">231 </span>   converted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L232" class="LineNr">232 </span>string
<span id="L233" class="LineNr">233 </span>   is the resultant character string <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L234" class="LineNr">234 </span>
<span id="L235" class="LineNr">235 </span>
<span id="L236" class="LineNr">236 </span>code
<span id="L237" class="LineNr">237 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be one of the following:
<span id="L238" class="LineNr">238 </span>   error_table_$smallarg
<span id="L239" class="LineNr">239 </span>      string is too short to hold the converted result <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot;
<span id="L240" class="LineNr">240 </span>      below<span class="textRainbow_lv0_p0">)</span>.
<span id="L241" class="LineNr">241 </span>   error_table_$ai_invalid_binary
<span id="L242" class="LineNr">242 </span>      either the level number or category set is invalid; the resulting
<span id="L243" class="LineNr">243 </span>      output is also invalid.
<span id="L244" class="LineNr">244 </span>   error_table_$ai_invalid_range
<span id="L245" class="LineNr">245 </span>      no error in conversion; but acc_att_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> does not represent
<span id="L246" class="LineNr">246 </span>      an access attribute greater than or equal to acc_att_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>.
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>
<span id="L249" class="LineNr">249 </span>Notes:  When the error_table_$smallarg code is returned, as much of the
<span id="L250" class="LineNr">250 </span>resulting conversion as fits in the output string is returned.
<span id="L251" class="LineNr">251 </span>However, since the results are not complete, they should not be used as
<span id="L252" class="LineNr">252 </span>input to the convert_access_class_$from_string entry point.
<span id="L253" class="LineNr">253 </span>
<span id="L254" class="LineNr">254 </span>If either of the access attributes is equal to the site access ceiling
<span id="L255" class="LineNr">255 </span>as defined by the installation_parms and returned by
<span id="L256" class="LineNr">256 </span>system_info_$access_ceiling, then &quot;system_high&quot; is returned in the
<span id="L257" class="LineNr">257 </span>string for that attribute.
<span id="L258" class="LineNr">258 </span>
<span id="L259" class="LineNr">259 </span>
<span id="L260" class="LineNr">260 </span>:Entry:  to_string_range_short: 02/27/85 convert_access_class_$to_string_range_short
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>
<span id="L263" class="LineNr">263 </span>Function:  This entry point is identical to the
<span id="L264" class="LineNr">264 </span>convert_access_class_$to_string_range entry point except that the short
<span id="L265" class="LineNr">265 </span>level/category names are returned.  Each short name has a maximum
<span id="L266" class="LineNr">266 </span>length of eight characters.  This output is also suitable for input to
<span id="L267" class="LineNr">267 </span>the convert_access_class_$from_string_range entry point.
<span id="L268" class="LineNr">268 </span>
<span id="L269" class="LineNr">269 </span>
<span id="L270" class="LineNr">270 </span>Syntax:
<span id="L271" class="LineNr">271 </span>declare convert_access_class_$to_string_range_short entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span>
<span id="L272" class="LineNr">272 </span>     aligned dimension<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span>;
<span id="L273" class="LineNr">273 </span>call convert_access_class_$to_string_range_short <span class="textRainbow_lv1_p0">(</span>acc_att_range<span class="textRainbow_lv1_o0">,</span>
<span id="L274" class="LineNr">274 </span>     string<span class="textRainbow_lv1_o0">,</span> code<span class="textRainbow_lv1_p0">)</span>;
<span id="L275" class="LineNr">275 </span>
<span id="L276" class="LineNr">276 </span>
<span id="L277" class="LineNr">277 </span>Arguments:
<span id="L278" class="LineNr">278 </span>acc_att_range
<span id="L279" class="LineNr">279 </span>   is the binary representation of an access attribute range range to
<span id="L280" class="LineNr">280 </span>   be converted.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L281" class="LineNr">281 </span>string
<span id="L282" class="LineNr">282 </span>   is the resultant character string <span class="textRainbow_lv1_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv1_p0">)</span>.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L283" class="LineNr">283 </span>
<span id="L284" class="LineNr">284 </span>
<span id="L285" class="LineNr">285 </span>code
<span id="L286" class="LineNr">286 </span>   is a standard status code.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span> It may be one of the following:
<span id="L287" class="LineNr">287 </span>   error_table_$smallarg
<span id="L288" class="LineNr">288 </span>      string is too short to hold the converted result <span class="textRainbow_lv1_p0">(</span>see &quot;Notes&quot;
<span id="L289" class="LineNr">289 </span>      below<span class="textRainbow_lv1_p0">)</span>.
<span id="L290" class="LineNr">290 </span>   error_table_$ai_invalid_binary
<span id="L291" class="LineNr">291 </span>      either the level number or category set is invalid; the resulting
<span id="L292" class="LineNr">292 </span>      output is also invalid.
<span id="L293" class="LineNr">293 </span>   error_table_$ai_invalid_range
<span id="L294" class="LineNr">294 </span>      no error in conversion; but acc_att_range <span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span> does not represent
<span id="L295" class="LineNr">295 </span>      an access attribute greater than or equal to acc_att_range <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span>.
<span id="L296" class="LineNr">296 </span>
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>Notes:  If either of the access attributes is equal to the site access
<span id="L299" class="LineNr">299 </span>ceiling as defined by the installation_parms and returned by
<span id="L300" class="LineNr">300 </span>system_info_$access_ceiling<span class="textRainbow_lv0_o0">,</span> then &quot;system_high&quot; is returned in the
<span id="L301" class="LineNr">301 </span>string for that attribute.
<span id="L302" class="LineNr">302 </span>
<span id="L303" class="LineNr">303 </span>
<span id="L304" class="LineNr">304 </span>:Entry:  to_string_short: 02/27/85 convert_access_class_$to_string_short
<span id="L305" class="LineNr">305 </span>
<span id="L306" class="LineNr">306 </span>
<span id="L307" class="LineNr">307 </span>Function:  This entry point is identical to the
<span id="L308" class="LineNr">308 </span>convert_access_class_$to_string entry point<span class="textRainbow_lv0_o0">,</span> except that the short
<span id="L309" class="LineNr">309 </span>level/category names are returned.  Each short name has a maximum
<span id="L310" class="LineNr">310 </span>length of eight characters.  This output is also suitable for input to
<span id="L311" class="LineNr">311 </span>the convert_access_class_$from_string entry point.
<span id="L312" class="LineNr">312 </span>
<span id="L313" class="LineNr">313 </span>
<span id="L314" class="LineNr">314 </span>Syntax:
<span id="L315" class="LineNr">315 </span>declare convert_access_class_$to_string_short entry <span class="textRainbow_lv1_p0">(</span>bit<span class="textRainbow_lv2_p0">(</span>72<span class="textRainbow_lv2_p0">)</span> aligned<span class="textRainbow_lv1_o0">,</span>
<span id="L316" class="LineNr">316 </span>     char<span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> fixed bin<span class="textRainbow_lv2_p0">(</span>35<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span>;
<span id="L317" class="LineNr">317 </span>call convert_access_class_$to_string_short <span class="textRainbow_lv1_p0">(</span>acc_att<span class="textRainbow_lv1_o0">,</span> string<span class="textRainbow_lv1_o0">,</span> code<span class="textRainbow_lv1_p0">)</span>;
<span id="L318" class="LineNr">318 </span>
<span id="L319" class="LineNr">319 </span>
<span id="L320" class="LineNr">320 </span>Arguments:
<span id="L321" class="LineNr">321 </span>acc_att
<span id="L322" class="LineNr">322 </span>   is the binary representation of an access attribute to be converted.
<span id="L323" class="LineNr">323 </span>   <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L324" class="LineNr">324 </span>string
<span id="L325" class="LineNr">325 </span>   is the resultant character string.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L326" class="LineNr">326 </span>code
<span id="L327" class="LineNr">327 </span>   is a standard status code.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span> It can be one of the following:
<span id="L328" class="LineNr">328 </span>   error_table_$smallarg
<span id="L329" class="LineNr">329 </span>      string is too short to hold the converted result <span class="textRainbow_lv1_p0">(</span>see &quot;Notes&quot;
<span id="L330" class="LineNr">330 </span>      below<span class="textRainbow_lv1_p0">)</span>.
<span id="L331" class="LineNr">331 </span>   error_table_$ai_invalid_binary
<span id="L332" class="LineNr">332 </span>      either the level number or category set is invalid; the resulting
<span id="L333" class="LineNr">333 </span>      output is also invalid.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
